<?php

declare(strict_types=1);

namespace Dedi\SyliusMigrationPlugin\Dto;

final class IdentifierMappingDefinition
{
    private readonly string $sourceTableName;

    private readonly string $sourceColumnName;

    private readonly string $destTableName;

    private readonly string $destColumnName;

    private function __construct(
        string $sourceTableName,
        string $sourceColumnName,
        string $destTableName,
        string $destColumnName,
    ) {
        $this->sourceTableName = $sourceTableName;
        $this->sourceColumnName = $sourceColumnName;
        $this->destTableName = $destTableName;
        $this->destColumnName = $destColumnName;
    }

    public static function fromArray(array $data): self
    {
        return new self($data['source_table'], $data['source_column'], $data['dest_table'], $data['dest_column']);
    }

    public function getSourceTableName(): string
    {
        return $this->sourceTableName;
    }

    public function getSourceColumnName(): string
    {
        return $this->sourceColumnName;
    }

    public function getDestTableName(): string
    {
        return $this->destTableName;
    }

    public function getDestColumnName(): string
    {
        return $this->destColumnName;
    }
}
